diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/template.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/template.php	2013-08-24 17:37:04.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/template.php	2013-10-06 05:56:09.000000000 -0500
***************
*** 24,39 ****
--- 24,74 ----
  	var $tree_type = 'category';
  	var $db_fields = array ('parent' => 'parent', 'id' => 'term_id'); //TODO: decouple this
  
+ 	/**
+ 	 * Starts the list before the elements are added.
+ 	 *
+ 	 * @see Walker:start_lvl()
+ 	 *
+ 	 * @since 2.5.1
+ 	 *
+ 	 * @param string $output Passed by reference. Used to append additional content.
+ 	 * @param int    $depth  Depth of category. Used for tab indentation.
+ 	 * @param array  $args   An array of arguments. @see wp_terms_checklist()
+ 	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "$indent<ul class='children'>\n";
  	}
  
+ 	/**
+ 	 * Ends the list of after the elements are added.
+ 	 *
+ 	 * @see Walker::end_lvl()
+ 	 *
+ 	 * @since 2.5.1
+ 	 *
+ 	 * @param string $output Passed by reference. Used to append additional content.
+ 	 * @param int    $depth  Depth of category. Used for tab indentation.
+ 	 * @param array  $args   An array of arguments. @see wp_terms_checklist()
+ 	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "$indent</ul>\n";
  	}
  
+ 	/**
+ 	 * Start the element output.
+ 	 *
+ 	 * @see Walker::start_el()
+ 	 *
+ 	 * @since 2.5.1
+ 	 *
+ 	 * @param string $output   Passed by reference. Used to append additional content.
+ 	 * @param object $category The current term object.
+ 	 * @param int    $depth    Depth of the term in reference to parents. Default 0.
+ 	 * @param array  $args     An array of arguments. @see wp_terms_checklist()
+ 	 * @param int    $id       ID of the current term.
+ 	 */
  	function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
  		extract($args);
  		if ( empty($taxonomy) )
***************
*** 48,53 ****
--- 83,100 ----
  		$output .= "\n<li id='{$taxonomy}-{$category->term_id}'$class>" . '<label class="selectit"><input value="' . $category->term_id . '" type="checkbox" name="'.$name.'[]" id="in-'.$taxonomy.'-' . $category->term_id . '"' . checked( in_array( $category->term_id, $selected_cats ), true, false ) . disabled( empty( $args['disabled'] ), false, false ) . ' /> ' . esc_html( apply_filters('the_category', $category->name )) . '</label>';
  	}
  
+ 	/**
+ 	 * Ends the element output, if needed.
+ 	 *
+ 	 * @see Walker::end_el()
+ 	 *
+ 	 * @since 2.5.1
+ 	 *
+ 	 * @param string $output   Passed by reference. Used to append additional content.
+ 	 * @param object $category The current term object.
+ 	 * @param int    $depth    Depth of the term in reference to parents. Default 0.
+ 	 * @param array  $args     An array of arguments. @see wp_terms_checklist()
+ 	 */
  	function end_el( &$output, $category, $depth = 0, $args = array() ) {
  		$output .= "</li>\n";
  	}
***************
*** 500,511 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 1.2.0
   */
! function meta_form() {
  	global $wpdb;
  	$limit = (int) apply_filters( 'postmeta_form_limit', 30 );
  	$keys = $wpdb->get_col( "
  		SELECT meta_key
--- 547,561 ----
  }
  
  /**
!  * Prints the form in the Custom Fields meta box.
   *
   * @since 1.2.0
+  *
+  * @param WP_Post $post Optional. The post being edited.
   */
! function meta_form( $post = null ) {
  	global $wpdb;
+ 	$post = get_post( $post );
  	$limit = (int) apply_filters( 'postmeta_form_limit', 30 );
  	$keys = $wpdb->get_col( "
  		SELECT meta_key
***************
*** 535,541 ****
  <?php
  
  	foreach ( $keys as $key ) {
! 		if ( is_protected_meta( $key, 'post' ) )
  			continue;
  		echo "\n<option value='" . esc_attr($key) . "'>" . esc_html($key) . "</option>";
  	}
--- 585,591 ----
  <?php
  
  	foreach ( $keys as $key ) {
! 		if ( is_protected_meta( $key, 'post' ) || ! current_user_can( 'add_post_meta', $post->ID, $key ) )
  			continue;
  		echo "\n<option value='" . esc_attr($key) . "'>" . esc_html($key) . "</option>";
  	}
***************
*** 696,752 ****
  }
  
  /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.0.0
-  *
-  * @param unknown_type $id
-  * @return unknown
-  */
- function the_attachment_links( $id = false ) {
- 	$id = (int) $id;
- 	$post = get_post( $id );
- 
- 	if ( $post->post_type != 'attachment' )
- 		return false;
- 
- 	$icon = wp_get_attachment_image( $post->ID, 'thumbnail', true );
- 	$attachment_data = wp_get_attachment_metadata( $id );
- 	$thumb = isset( $attachment_data['thumb'] );
- ?>
- <form id="the-attachment-links">
- <table>
- 	<col />
- 	<col class="widefat" />
- 	<tr>
- 		<th scope="row"><?php _e( 'URL' ) ?></th>
- 		<td><textarea rows="1" cols="40" type="text" class="attachmentlinks" readonly="readonly"><?php echo esc_textarea( wp_get_attachment_url() ); ?></textarea></td>
- 	</tr>
- <?php if ( $icon ) : ?>
- 	<tr>
- 		<th scope="row"><?php $thumb ? _e( 'Thumbnail linked to file' ) : _e( 'Image linked to file' ); ?></th>
- 		<td><textarea rows="1" cols="40" type="text" class="attachmentlinks" readonly="readonly"><a href="<?php echo wp_get_attachment_url(); ?>"><?php echo $icon ?></a></textarea></td>
- 	</tr>
- 	<tr>
- 		<th scope="row"><?php $thumb ? _e( 'Thumbnail linked to page' ) : _e( 'Image linked to page' ); ?></th>
- 		<td><textarea rows="1" cols="40" type="text" class="attachmentlinks" readonly="readonly"><a href="<?php echo get_attachment_link( $post->ID ) ?>" rel="attachment wp-att-<?php echo $post->ID; ?>"><?php echo $icon ?></a></textarea></td>
- 	</tr>
- <?php else : ?>
- 	<tr>
- 		<th scope="row"><?php _e( 'Link to file' ) ?></th>
- 		<td><textarea rows="1" cols="40" type="text" class="attachmentlinks" readonly="readonly"><a href="<?php echo wp_get_attachment_url(); ?>" class="attachmentlink"><?php echo basename( wp_get_attachment_url() ); ?></a></textarea></td>
- 	</tr>
- 	<tr>
- 		<th scope="row"><?php _e( 'Link to page' ) ?></th>
- 		<td><textarea rows="1" cols="40" type="text" class="attachmentlinks" readonly="readonly"><a href="<?php echo get_attachment_link( $post->ID ) ?>" rel="attachment wp-att-<?php echo $post->ID ?>"><?php the_title(); ?></a></textarea></td>
- 	</tr>
- <?php endif; ?>
- </table>
- </form>
- <?php
- }
- 
- /**
   * Print out <option> html elements for role selectors
   *
   * @since 2.1.0
--- 746,751 ----
***************
*** 757,763 ****
  	$p = '';
  	$r = '';
  
! 	$editable_roles = get_editable_roles();
  
  	foreach ( $editable_roles as $role => $details ) {
  		$name = translate_user_role($details['name'] );
--- 756,762 ----
  	$p = '';
  	$r = '';
  
! 	$editable_roles = array_reverse( get_editable_roles() );
  
  	foreach ( $editable_roles as $role => $details ) {
  		$name = translate_user_role($details['name'] );
***************
*** 1072,1084 ****
  		$page = 'reading';
  	}
  
- 	if ( !isset($wp_settings_sections) )
- 		$wp_settings_sections = array();
- 	if ( !isset($wp_settings_sections[$page]) )
- 		$wp_settings_sections[$page] = array();
- 	if ( !isset($wp_settings_sections[$page][$id]) )
- 		$wp_settings_sections[$page][$id] = array();
- 
  	$wp_settings_sections[$page][$id] = array('id' => $id, 'title' => $title, 'callback' => $callback);
  }
  
--- 1071,1076 ----
***************
*** 1117,1129 ****
  		$page = 'reading';
  	}
  
- 	if ( !isset($wp_settings_fields) )
- 		$wp_settings_fields = array();
- 	if ( !isset($wp_settings_fields[$page]) )
- 		$wp_settings_fields[$page] = array();
- 	if ( !isset($wp_settings_fields[$page][$section]) )
- 		$wp_settings_fields[$page][$section] = array();
- 
  	$wp_settings_fields[$page][$section][$id] = array('id' => $id, 'title' => $title, 'callback' => $callback, 'args' => $args);
  }
  
--- 1109,1114 ----
***************
*** 1143,1149 ****
  function do_settings_sections( $page ) {
  	global $wp_settings_sections, $wp_settings_fields;
  
! 	if ( ! isset( $wp_settings_sections ) || !isset( $wp_settings_sections[$page] ) )
  		return;
  
  	foreach ( (array) $wp_settings_sections[$page] as $section ) {
--- 1128,1134 ----
  function do_settings_sections( $page ) {
  	global $wp_settings_sections, $wp_settings_fields;
  
! 	if ( ! isset( $wp_settings_sections[$page] ) )
  		return;
  
  	foreach ( (array) $wp_settings_sections[$page] as $section ) {
***************
*** 1178,1184 ****
  function do_settings_fields($page, $section) {
  	global $wp_settings_fields;
  
! 	if ( !isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section]) )
  		return;
  
  	foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
--- 1163,1169 ----
  function do_settings_fields($page, $section) {
  	global $wp_settings_fields;
  
! 	if ( ! isset( $wp_settings_fields[$page][$section] ) )
  		return;
  
  	foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
***************
*** 1219,1227 ****
  function add_settings_error( $setting, $code, $message, $type = 'error' ) {
  	global $wp_settings_errors;
  
- 	if ( !isset($wp_settings_errors) )
- 		$wp_settings_errors = array();
- 
  	$new_error = array(
  		'setting' => $setting,
  		'code' => $code,
--- 1204,1209 ----
***************
*** 1256,1262 ****
  function get_settings_errors( $setting = '', $sanitize = false ) {
  	global $wp_settings_errors;
  
! 	// If $sanitize is true, manually re-run the sanitizisation for this option
  	// This allows the $sanitize_callback from register_setting() to run, adding
  	// any settings errors you want to show by default.
  	if ( $sanitize )
--- 1238,1244 ----
  function get_settings_errors( $setting = '', $sanitize = false ) {
  	global $wp_settings_errors;
  
! 	// If $sanitize is true, manually re-run the sanitization for this option
  	// This allows the $sanitize_callback from register_setting() to run, adding
  	// any settings errors you want to show by default.
  	if ( $sanitize )
***************
*** 1453,1458 ****
--- 1435,1444 ----
  do_action('admin_head');
  
  $admin_body_class .= ' locale-' . sanitize_html_class( strtolower( str_replace( '_', '-', get_locale() ) ) );
+ 
+ if ( is_rtl() )
+ 	$admin_body_class .= ' rtl';
+ 
  ?>
  </head>
  <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="wp-admin wp-core-ui no-js iframe <?php echo apply_filters( 'admin_body_class', '' ) . ' ' . $admin_body_class; ?>">
***************
*** 1905,1911 ****
  		$content  = '<h3>' . __( 'Compare Revisions' ) . '</h3>';
  		$content .= '<p>' . __( 'View, compare, and restore other versions of this content on the improved revisions screen.' ) . '</p>';
  
! 		self::print_js( 'wp360_revisions', '.misc-pub-section.num-revisions', array(
  			'content' => $content,
  			'position' => array( 'edge' => is_rtl() ? 'left' : 'right', 'align' => 'center', 'my' => is_rtl() ? 'left' : 'right-14px' ),
  		) );
--- 1891,1897 ----
  		$content  = '<h3>' . __( 'Compare Revisions' ) . '</h3>';
  		$content .= '<p>' . __( 'View, compare, and restore other versions of this content on the improved revisions screen.' ) . '</p>';
  
! 		self::print_js( 'wp360_revisions', '.misc-pub-section.misc-pub-revisions', array(
  			'content' => $content,
  			'position' => array( 'edge' => is_rtl() ? 'left' : 'right', 'align' => 'center', 'my' => is_rtl() ? 'left' : 'right-14px' ),
  		) );
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/theme.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/theme.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/theme.php	2013-07-08 12:10:47.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/theme.php	2013-09-09 02:54:11.000000000 -0500
***************
*** 282,288 ****
  	$res = apply_filters('themes_api', false, $action, $args); //NOTE: Allows a theme to completely override the builtin WordPress.org API.
  
  	if ( ! $res ) {
! 		$request = wp_remote_post('http://api.wordpress.org/themes/info/1.0/', array( 'body' => array('action' => $action, 'request' => serialize($args))) );
  		if ( is_wp_error($request) ) {
  			$res = new WP_Error('themes_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), $request->get_error_message() );
  		} else {
--- 282,298 ----
  	$res = apply_filters('themes_api', false, $action, $args); //NOTE: Allows a theme to completely override the builtin WordPress.org API.
  
  	if ( ! $res ) {
! 		$url = 'http://api.wordpress.org/themes/info/1.0/';
! 		if ( wp_http_supports( array( 'ssl' ) ) )
! 			$url = set_url_scheme( $url, 'https' );
! 
! 		$request = wp_remote_post( $url, array(
! 			'body' => array(
! 				'action' => $action,
! 				'request' => serialize( $args )
! 			)
! 		) );
! 
  		if ( is_wp_error($request) ) {
  			$res = new WP_Error('themes_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), $request->get_error_message() );
  		} else {
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/update-core.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/update-core.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/update-core.php	2013-08-07 13:05:02.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/update-core.php	2013-10-24 14:29:10.000000000 -0500
***************
*** 558,563 ****
--- 558,567 ----
  'wp-admin/js/categories.min.js',
  'wp-admin/js/custom-fields.js',
  'wp-admin/js/custom-fields.min.js',
+ // 3.7
+ 'wp-admin/js/cat.js',
+ 'wp-admin/js/cat.min.js',
+ 'wp-includes/js/tinymce/plugins/wpeditimage/js/editimage.min.js',
  );
  
  /**
***************
*** 658,668 ****
  	$versions_file = trailingslashit( $wp_filesystem->wp_content_dir() ) . 'upgrade/version-current.php';
  	if ( ! $wp_filesystem->copy( $from . $distro . 'wp-includes/version.php', $versions_file ) ) {
  		 $wp_filesystem->delete( $from, true );
! 		 return new WP_Error( 'copy_failed', __('Could not copy file.') );
  	}
  
  	$wp_filesystem->chmod( $versions_file, FS_CHMOD_FILE );
! 	require_once( WP_CONTENT_DIR . '/upgrade/version-current.php' );
  	$wp_filesystem->delete( $versions_file );
  
  	$php_version    = phpversion();
--- 662,672 ----
  	$versions_file = trailingslashit( $wp_filesystem->wp_content_dir() ) . 'upgrade/version-current.php';
  	if ( ! $wp_filesystem->copy( $from . $distro . 'wp-includes/version.php', $versions_file ) ) {
  		 $wp_filesystem->delete( $from, true );
! 		 return new WP_Error( 'copy_failed_for_version_file', __( 'The update cannot be installed because we will be unable to copy some files. This is usually due to inconsistent file permissions.' ), 'wp-includes/version.php' );
  	}
  
  	$wp_filesystem->chmod( $versions_file, FS_CHMOD_FILE );
! 	require( WP_CONTENT_DIR . '/upgrade/version-current.php' );
  	$wp_filesystem->delete( $versions_file );
  
  	$php_version    = phpversion();
***************
*** 685,700 ****
  	elseif ( !$mysql_compat )
  		return new WP_Error( 'mysql_not_compatible', sprintf( __('The update cannot be installed because WordPress %1$s requires MySQL version %2$s or higher. You are running version %3$s.'), $wp_version, $required_mysql_version, $mysql_version ) );
  
! 	apply_filters('update_feedback', __('Installing the latest version&#8230;'));
  
  	// Create maintenance file to signal that we are upgrading
  	$maintenance_string = '<?php $upgrading = ' . time() . '; ?>';
  	$maintenance_file = $to . '.maintenance';
  	$wp_filesystem->delete($maintenance_file);
  	$wp_filesystem->put_contents($maintenance_file, $maintenance_string, FS_CHMOD_FILE);
  
  	// Copy new versions of WP files into place.
! 	$result = _copy_dir($from . $distro, $to, array('wp-content') );
  
  	// Custom Content Directory needs updating now.
  	// Copy Languages
--- 689,788 ----
  	elseif ( !$mysql_compat )
  		return new WP_Error( 'mysql_not_compatible', sprintf( __('The update cannot be installed because WordPress %1$s requires MySQL version %2$s or higher. You are running version %3$s.'), $wp_version, $required_mysql_version, $mysql_version ) );
  
! 	apply_filters( 'update_feedback', __( 'Preparing to install the latest version&#8230;' ) );
  
+ 	// Don't copy wp-content, we'll deal with that below
+ 	$skip = array( 'wp-content' );
+ 	$check_is_writable = array();
+ 
+ 	// Check to see which files don't really need updating - only available for 3.7 and higher
+ 	if ( function_exists( 'get_core_checksums' ) ) {
+ 		$checksums = get_core_checksums( $wp_version, isset( $wp_local_package ) ? $wp_local_package : 'en_US' );
+ 		if ( is_array( $checksums ) && isset( $checksums[ $wp_version ] ) )
+ 			$checksums = $checksums[ $wp_version ]; // Compat code for 3.7-beta2
+ 		if ( is_array( $checksums ) ) {
+ 			foreach( $checksums as $file => $checksum ) {
+ 				if ( 'wp-content' == substr( $file, 0, 10 ) )
+ 					continue;
+ 				if ( ! file_exists( ABSPATH . $file ) )
+ 					continue;
+ 				if ( md5_file( ABSPATH . $file ) === $checksum )
+ 					$skip[] = $file;
+ 				else
+ 					$check_is_writable[ $file ] = ABSPATH . $file;
+ 			}
+ 		}
+ 	}
+ 
+ 	// If we're using the direct method, we can predict write failures that are due to permissions.
+ 	if ( $check_is_writable && 'direct' === $wp_filesystem->method ) {
+ 		$files_writable = array_filter( $check_is_writable, array( $wp_filesystem, 'is_writable' ) );
+ 		if ( $files_writable !== $check_is_writable ) {
+ 			$files_not_writable = array_diff_key( $check_is_writable, $files_writable );
+ 			foreach ( $files_not_writable as $relative_file_not_writable => $file_not_writable ) {
+ 				// If the writable check failed, chmod file to 0644 and try again, same as copy_dir().
+ 				$wp_filesystem->chmod( $file_not_writable, FS_CHMOD_FILE );
+ 				if ( $wp_filesystem->is_writable( $file_not_writable ) )
+ 					unset( $files_not_writable[ $relative_file_not_writable ] );
+ 			}
+ 
+ 			// Store package-relative paths (the key) of non-writable files in the WP_Error object.
+ 			$error_data = version_compare( $old_wp_version, '3.7-beta2', '>' ) ? array_keys( $files_not_writable ) : '';
+ 
+ 			if ( $files_not_writable )
+ 				return new WP_Error( 'files_not_writable', __( 'The update cannot be installed because we will be unable to copy some files. This is usually due to inconsistent file permissions.' ), implode( ', ', $error_data ) );
+ 		}
+ 	}
+ 
+ 	apply_filters( 'update_feedback', __( 'Enabling Maintenance mode&#8230;' ) );
  	// Create maintenance file to signal that we are upgrading
  	$maintenance_string = '<?php $upgrading = ' . time() . '; ?>';
  	$maintenance_file = $to . '.maintenance';
  	$wp_filesystem->delete($maintenance_file);
  	$wp_filesystem->put_contents($maintenance_file, $maintenance_string, FS_CHMOD_FILE);
  
+ 	apply_filters( 'update_feedback', __( 'Copying the required files&#8230;' ) );
  	// Copy new versions of WP files into place.
! 	$result = _copy_dir( $from . $distro, $to, $skip );
! 	if ( is_wp_error( $result ) )
! 		$result = new WP_Error( $result->get_error_code(), $result->get_error_message(), substr( $result->get_error_data(), strlen( $to ) ) );
! 
! 	// Check to make sure everything copied correctly, ignoring the contents of wp-content
! 	$skip = array( 'wp-content' );
! 	$failed = array();
! 	if ( is_array( $checksums ) ) {
! 		foreach ( $checksums as $file => $checksum ) {
! 			if ( 0 === strpos( $file, 'wp-content' ) )
! 				continue;
! 
! 			if ( file_exists( ABSPATH . $file ) && md5_file( ABSPATH . $file ) == $checksum )
! 				$skip[] = $file;
! 			else
! 				$failed[] = $file;
! 		}
! 	}
! 
! 	// Some files didn't copy properly
! 	if ( ! empty( $failed ) ) {
! 		$total_size = 0;
! 		// Find the local version of the working directory
! 		$working_dir_local = WP_CONTENT_DIR . '/upgrade/' . basename( $from ) . $distro;
! 		foreach ( $failed as $file ) {
! 			if ( file_exists( $working_dir_local . $file ) )
! 				$total_size += filesize( $working_dir_local . $file );
! 		}
! 
! 		// If we don't have enough free space, it isn't worth trying again.
! 		// Unlikely to be hit due to the check in unzip_file().
! 		$available_space = @disk_free_space( ABSPATH );
! 		if ( $available_space && $total_size >= $available_space ) {
! 			$result = new WP_Error( 'disk_full', __( 'There is not enough free disk space to complete the update.' ) );
! 		} else {
! 			$result = _copy_dir( $from . $distro, $to, $skip );
! 			if ( is_wp_error( $result ) )
! 				$result = new WP_Error( $result->get_error_code() . '_retry', $result->get_error_message(), substr( $result->get_error_data(), strlen( $to ) ) );
! 		}
! 	}
  
  	// Custom Content Directory needs updating now.
  	// Copy Languages
***************
*** 711,721 ****
  
  		if ( @is_dir($lang_dir) ) {
  			$wp_lang_dir = $wp_filesystem->find_folder($lang_dir);
! 			if ( $wp_lang_dir )
  				$result = copy_dir($from . $distro . 'wp-content/languages/', $wp_lang_dir);
  		}
  	}
  
  	// 3.5 -> 3.5+ - an empty twentytwelve directory was created upon upgrade to 3.5 for some users, preventing installation of Twenty Twelve.
  	if ( '3.5' == $old_wp_version ) {
  		if ( is_dir( WP_CONTENT_DIR . '/themes/twentytwelve' ) && ! file_exists( WP_CONTENT_DIR . '/themes/twentytwelve/style.css' )  ) {
--- 799,816 ----
  
  		if ( @is_dir($lang_dir) ) {
  			$wp_lang_dir = $wp_filesystem->find_folder($lang_dir);
! 			if ( $wp_lang_dir ) {
  				$result = copy_dir($from . $distro . 'wp-content/languages/', $wp_lang_dir);
+ 				if ( is_wp_error( $result ) )
+ 					$result = new WP_Error( $result->get_error_code() . '_languages', $result->get_error_message(), substr( $result->get_error_data(), strlen( $wp_lang_dir ) ) );
+ 			}
  		}
  	}
  
+ 	apply_filters( 'update_feedback', __( 'Disabling Maintenance mode&#8230;' ) );
+ 	// Remove maintenance file, we're done with potential site-breaking changes
+ 	$wp_filesystem->delete( $maintenance_file );
+ 
  	// 3.5 -> 3.5+ - an empty twentytwelve directory was created upon upgrade to 3.5 for some users, preventing installation of Twenty Twelve.
  	if ( '3.5' == $old_wp_version ) {
  		if ( is_dir( WP_CONTENT_DIR . '/themes/twentytwelve' ) && ! file_exists( WP_CONTENT_DIR . '/themes/twentytwelve/style.css' )  ) {
***************
*** 749,763 ****
  						continue;
  
  					if ( ! $wp_filesystem->copy($from . $distro . 'wp-content/' . $file, $dest . $filename, FS_CHMOD_FILE) )
! 						$result = new WP_Error('copy_failed', __('Could not copy file.'), $dest . $filename);
  				} else {
  					if ( ! $development_build && $wp_filesystem->is_dir( $dest . $filename ) )
  						continue;
  
  					$wp_filesystem->mkdir($dest . $filename, FS_CHMOD_DIR);
  					$_result = copy_dir( $from . $distro . 'wp-content/' . $file, $dest . $filename);
! 					if ( is_wp_error($_result) ) //If a error occurs partway through this final step, keep the error flowing through, but keep process going.
! 						$result = $_result;
  				}
  			}
  		} //end foreach
--- 844,863 ----
  						continue;
  
  					if ( ! $wp_filesystem->copy($from . $distro . 'wp-content/' . $file, $dest . $filename, FS_CHMOD_FILE) )
! 						$result = new WP_Error( "copy_failed_for_new_bundled_$type", __( 'Could not copy file.' ), $dest . $filename );
  				} else {
  					if ( ! $development_build && $wp_filesystem->is_dir( $dest . $filename ) )
  						continue;
  
  					$wp_filesystem->mkdir($dest . $filename, FS_CHMOD_DIR);
  					$_result = copy_dir( $from . $distro . 'wp-content/' . $file, $dest . $filename);
! 
! 					// If a error occurs partway through this final step, keep the error flowing through, but keep process going.
! 					if ( is_wp_error( $_result ) ) {
! 						if ( ! is_wp_error( $result ) )
! 							$result = new WP_Error;
! 						$result->add( $_result->get_error_code() . "_$type", $_result->get_error_message(), substr( $_result->get_error_data(), strlen( $dest ) ) );
! 					}
  				}
  			}
  		} //end foreach
***************
*** 765,771 ****
  
  	// Handle $result error from the above blocks
  	if ( is_wp_error($result) ) {
- 		$wp_filesystem->delete($maintenance_file);
  		$wp_filesystem->delete($from, true);
  		return $result;
  	}
--- 865,870 ----
***************
*** 792,803 ****
  	else
  		delete_option('update_core');
  
- 	// Remove maintenance file, we're done.
- 	$wp_filesystem->delete($maintenance_file);
- 
  	// If we made it this far:
  	do_action( '_core_updated_successfully', $wp_version );
  
  	return $wp_version;
  }
  
--- 891,903 ----
  	else
  		delete_option('update_core');
  
  	// If we made it this far:
  	do_action( '_core_updated_successfully', $wp_version );
  
+ 	// Clear the option that blocks auto updates after failures, now that we've been successful.
+ 	if ( function_exists( 'delete_site_option' ) )
+ 		delete_site_option( 'auto_core_update_failed' );
+ 
  	return $wp_version;
  }
  
***************
*** 805,814 ****
   * Copies a directory from one location to another via the WordPress Filesystem Abstraction.
   * Assumes that WP_Filesystem() has already been called and setup.
   *
!  * This is a temporary function for the 3.1 -> 3.2 upgrade only and will be removed in 3.3
   *
   * @ignore
   * @since 3.2.0
   * @see copy_dir()
   *
   * @param string $from source directory
--- 905,916 ----
   * Copies a directory from one location to another via the WordPress Filesystem Abstraction.
   * Assumes that WP_Filesystem() has already been called and setup.
   *
!  * This is a temporary function for the 3.1 -> 3.2 upgrade, as well as for those upgrading to
!  * 3.7+
   *
   * @ignore
   * @since 3.2.0
+  * @since 3.7.0 Updated not to use a regular expression for the skip list
   * @see copy_dir()
   *
   * @param string $from source directory
***************
*** 824,854 ****
  	$from = trailingslashit($from);
  	$to = trailingslashit($to);
  
- 	$skip_regex = '';
- 	foreach ( (array)$skip_list as $key => $skip_file )
- 		$skip_regex .= preg_quote($skip_file, '!') . '|';
- 
- 	if ( !empty($skip_regex) )
- 		$skip_regex = '!(' . rtrim($skip_regex, '|') . ')$!i';
- 
  	foreach ( (array) $dirlist as $filename => $fileinfo ) {
! 		if ( !empty($skip_regex) )
! 			if ( preg_match($skip_regex, $from . $filename) )
! 				continue;
  
  		if ( 'f' == $fileinfo['type'] ) {
  			if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) ) {
  				// If copy failed, chmod file to 0644 and try again.
! 				$wp_filesystem->chmod($to . $filename, 0644);
  				if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) )
! 					return new WP_Error('copy_failed', __('Could not copy file.'), $to . $filename);
  			}
  		} elseif ( 'd' == $fileinfo['type'] ) {
  			if ( !$wp_filesystem->is_dir($to . $filename) ) {
  				if ( !$wp_filesystem->mkdir($to . $filename, FS_CHMOD_DIR) )
! 					return new WP_Error('mkdir_failed', __('Could not create directory.'), $to . $filename);
  			}
! 			$result = _copy_dir($from . $filename, $to . $filename, $skip_list);
  			if ( is_wp_error($result) )
  				return $result;
  		}
--- 926,956 ----
  	$from = trailingslashit($from);
  	$to = trailingslashit($to);
  
  	foreach ( (array) $dirlist as $filename => $fileinfo ) {
! 		if ( in_array( $filename, $skip_list ) )
! 			continue;
  
  		if ( 'f' == $fileinfo['type'] ) {
  			if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) ) {
  				// If copy failed, chmod file to 0644 and try again.
! 				$wp_filesystem->chmod( $to . $filename, FS_CHMOD_FILE );
  				if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) )
! 					return new WP_Error( 'copy_failed__copy_dir', __( 'Could not copy file.' ), $to . $filename );
  			}
  		} elseif ( 'd' == $fileinfo['type'] ) {
  			if ( !$wp_filesystem->is_dir($to . $filename) ) {
  				if ( !$wp_filesystem->mkdir($to . $filename, FS_CHMOD_DIR) )
! 					return new WP_Error( 'mkdir_failed__copy_dir', __( 'Could not create directory.' ), $to . $filename );
! 			}
! 
! 			// generate the $sub_skip_list for the subdirectory as a sub-set of the existing $skip_list
! 			$sub_skip_list = array();
! 			foreach ( $skip_list as $skip_item ) {
! 				if ( 0 === strpos( $skip_item, $filename . '/' ) )
! 					$sub_skip_list[] = preg_replace( '!^' . preg_quote( $filename, '!' ) . '/!i', '', $skip_item );
  			}
! 
! 			$result = _copy_dir($from . $filename, $to . $filename, $sub_skip_list);
  			if ( is_wp_error($result) )
  				return $result;
  		}
***************
*** 870,876 ****
  	if ( version_compare( $wp_version, '3.4-RC1', '>=' ) )
  		return;
  
! 	// Ensure we only run this on the update-core.php page. wp_update_core() could be called in other contexts.
  	if ( 'update-core.php' != $pagenow )
  		return;
  
--- 972,978 ----
  	if ( version_compare( $wp_version, '3.4-RC1', '>=' ) )
  		return;
  
! 	// Ensure we only run this on the update-core.php page. The Core_Upgrader may be used in other contexts.
  	if ( 'update-core.php' != $pagenow )
  		return;
  
